import { Config } from "./Config";
import { TopLevels } from "./Type";
import { RenderResult } from "./Renderer";
import { OptionDefinition } from "./RendererOptions";
import { SerializedRenderResult } from "./Source";
import { RendererOptions } from "./quicktype";
export declare abstract class TargetLanguage {
    readonly displayName: string;
    readonly names: string[];
    readonly extension: string;
    readonly optionDefinitions: OptionDefinition[];
    constructor(displayName: string, names: string[], extension: string, optionDefinitions: OptionDefinition[]);
    abstract transformAndRenderConfig(config: Config): SerializedRenderResult;
    abstract needsCompressedJSONInput(rendererOptions: RendererOptions): boolean;
}
export declare abstract class TypeScriptTargetLanguage extends TargetLanguage {
    transformAndRenderConfig(config: Config): SerializedRenderResult;
    needsCompressedJSONInput(rendererOptions: RendererOptions): boolean;
    protected readonly indentation: string;
    protected readonly supportsEnums: boolean;
    protected abstract renderGraph(topLevels: TopLevels, optionValues: {
        [name: string]: any;
    }): RenderResult;
}
