"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var immutable_1 = require("immutable");
var Source_1 = require("./Source");
var Inference_1 = require("./Inference");
var CombineClasses_1 = require("./CombineClasses");
var JSONSchemaInput_1 = require("./JSONSchemaInput");
var TargetLanguage = /** @class */ (function () {
    function TargetLanguage(displayName, names, extension, optionDefinitions) {
        this.displayName = displayName;
        this.names = names;
        this.extension = extension;
        this.optionDefinitions = optionDefinitions;
    }
    return TargetLanguage;
}());
exports.TargetLanguage = TargetLanguage;
var TypeScriptTargetLanguage = /** @class */ (function (_super) {
    __extends(TypeScriptTargetLanguage, _super);
    function TypeScriptTargetLanguage() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    TypeScriptTargetLanguage.prototype.transformAndRenderConfig = function (config) {
        var graph;
        if (config.isInputJSONSchema) {
            graph = immutable_1.Map();
            for (var _i = 0, _a = config.topLevels; _i < _a.length; _i++) {
                var tlc = _a[_i];
                // FIXME: This is ugly
                graph = graph.set(tlc.name, JSONSchemaInput_1.schemaToType(tlc.name, tlc.schema));
            }
        }
        else {
            var inference_1 = new Inference_1.TypeInference(config.inferMaps, this.supportsEnums && config.inferEnums);
            graph = immutable_1.Map(config.topLevels.map(function (tlc) {
                return [
                    tlc.name,
                    inference_1.inferType(config.compressedJSON, tlc.name, tlc.samples)
                ];
            }));
            if (config.combineClasses) {
                graph = CombineClasses_1.combineClasses(graph);
            }
        }
        if (!config.doRender) {
            return { lines: ["Done.", ""], annotations: immutable_1.List() };
        }
        var renderResult = this.renderGraph(graph, config.rendererOptions);
        return Source_1.serializeRenderResult(renderResult, this.indentation);
    };
    TypeScriptTargetLanguage.prototype.needsCompressedJSONInput = function (rendererOptions) {
        return true;
    };
    Object.defineProperty(TypeScriptTargetLanguage.prototype, "indentation", {
        get: function () {
            return "    ";
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TypeScriptTargetLanguage.prototype, "supportsEnums", {
        get: function () {
            return true;
        },
        enumerable: true,
        configurable: true
    });
    return TypeScriptTargetLanguage;
}(TargetLanguage));
exports.TypeScriptTargetLanguage = TypeScriptTargetLanguage;
